/*
  Copyright (c) 2007 Stefan Kurtz <kurtz@zbh.uni-hamburg.de>
  Copyright (c) 2007 Center for Bioinformatics, University of Hamburg

  Permission to use, copy, modify, and distribute this software for any
  purpose with or without fee is hereby granted, provided that the above
  copyright notice and this permission notice appear in all copies.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef PARTSSUF_DEF_H
#define PARTSSUF_DEF_H

typedef struct Suftabparts Suftabparts;

Suftabparts *newsuftabparts(unsigned int numofparts,
                            const Seqpos *leftborder,
                            Codetype numofallcodes,
                            Seqpos numofsuffixestoinsert,
                            Seqpos fullspecials,
                            Env *env);

Codetype stpgetcurrentmincode(unsigned int part,
                              const Suftabparts *suftabparts);

uint64_t stpgetcurrentsuftaboffset(unsigned int part,
                                   const Suftabparts *suftabparts);

Codetype stpgetcurrentmaxcode(unsigned int part,
                              const Suftabparts *suftabparts);

uint64_t stpgetcurrentsumofwdith(unsigned int part,
                                 const Suftabparts *suftabparts);

Seqpos stpgetcurrentwidthofpart(unsigned int part,
                                const Suftabparts *suftabparts);

Seqpos stpgetlargestwidth(const Suftabparts *suftabparts);

unsigned int stpgetnumofparts(const Suftabparts *suftabparts);

void freesuftabparts(Suftabparts *suftabparts,Env *env);

#endif
